#if !defined(LISTA_H_)
#define LISTA_H_           

typedef struct elem {
  /** elemento chiave */
  char *key;
  /** prossimo elemento */
  struct elem * next;
  /** elemento precedente */
  struct elem * prev;
} elem_t;
 
// tipo della funzione utilizzata per fare il compare
typedef int (*compare_t)(const char *, const char *);

typedef struct {
    /** la testa della lista */
    elem_t * head;
    /** questa e' la funzione per confrontare due chiavi */
    compare_t compare;
} list_t;

// macros di utilita'
#define CHECK_EQ(X, val, str)					      \
    if ((X)==val) {						      \
	perror(#str);						      \
	printf("ERRORE ALLA LINEA %d FILE %s\n", __LINE__, __FILE__); \
	exit(EXIT_FAILURE);					      \
    }
#define CHECK_NEQ(X, val, str)					      \
    if ((X)!=val) {						      \
	perror(#str);						      \
	printf("ERRORE ALLA LINEA %d FILE %s\n", __LINE__, __FILE__); \
	exit(EXIT_FAILURE);					      \
    }

// interfaccia della lista
list_t *createList();
int     destroyList(list_t *L);
int     insertList(list_t *L, const char *);
void    printList(list_t *L);

#endif /* LISTA_H_ */
